#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'verbose_truth'
require 'colours/colours_e_autoinclude.rb'
require 'cliner'
require 'ftp_paradise'

@counter = 0

# =========================================================================== #
# === fancy_colour
#
# Through a Konsole-colour.
# =========================================================================== #
def fancy_colour(i)
  ::Colours.springgreen(i)
end; alias main_colour fancy_colour # === main_colour

# =========================================================================== #
# === counter
#
# We return a colourized-counter here.
# =========================================================================== #
def counter
  @counter += 1
  return ::Colours.peachpuff('('+@counter.to_s+') ')
end

e 'Now testing the project called '+sfancy('ftp_paradise')+'.'
e 'Will we use colours?'
e VerboseTruth[FtpParadise.use_colours?]
e
e 'Next, we will instantiate a new FtpParadise::Connection object.'
connection = FtpParadise::Connection.new { :default_dataset }
# library.set_data :shevy # <-- This is not necessary.
pp connection
cliner
# =========================================================================== #
# === Feedback the configuration object
# =========================================================================== #
e 'The configuration object is:'
pp FtpParadise.config?
pp FtpParadise::CONFIGURATION
e '^^^ should be the same'
cliner
e 'Next, we will test some colours:'
FtpParadise.testing_colours # Making some colour-tests next.
cliner
e 'Next, we will show the user name, port and password:'
connection.show_host_user_name_port_and_password
cliner
e counter+'Now testing the '+fancy_colour('class FtpParadise::Connection')
connection = FtpParadise::Connection.new(:default)
e 'Will we debug? '+VerboseTruth[connection.debug?]
e 'The user name is: '+::Colours.orchid(connection.user_name?)
e 'Next showing the FtpParadise::Connection object:'
pp connection # test_ftp
connection.set_passive
connection.set_mode
connection.cd 'ZEUGNISSE'
e 'Next testing the method '+main_colour('.nlst()')
connection.nlst
e 'Debugging next:'
connection.debug
e 'We are connected to?'
e '  '+::Colours.deepskyblue(connection.connected_to?)
connection.report_remote_directory
# connection.upload 'LPC_CODE_SHEET'
e 'Is CSS/ a directory? '+connection.is_directory?('CSS').to_s
e 'The last response was: `'+connection.last_response?.chomp+'`'
e 'open_timeout? '+connection.open_timeout?.to_s # ftplib
e 'Next testing '+main_colour('FtpParadise.connect')+' functionality'
FtpParadise.connect to: :shevy
# =========================================================================== #
# Testing whether we will transfer in binary mode:
# =========================================================================== #
cliner
e 'Will we transfer in binary mode? '+VerboseTruth[connection.binary?].to_s
cliner
e 'Next, we will test '+simp('FtpParadise.mlsd()')+' but only the first entry there:'
e FtpParadise.mlsd.first
e FtpParadise.mlsd.first.class
# =========================================================================== #
# Ok, done testing FtpParadise::Connection.
# =========================================================================== #

# =========================================================================== #
# Now we can test interactive FTP. This must come last because it will
# start up the interactive variant.
# =========================================================================== #
interactive = FtpParadise.interactive(:no_main_loop)
interactive.run