#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# This small .rb file will just show how to quickly connect to a default
# host that I use. I have the login information stored in a yaml file.
# =========================================================================== #
require 'yaml'
require 'colours/colours_e_autoinclude.rb'
require 'net/ftp'

e Colours.rev+'Now testing a minimal FTP example.'

_ = '/home/x/DATA/PC/OS/LINUX/FTP/YAML/roebe_ftp.yml'
dataset = YAML.load_file(_)['bytehost']
url       = dataset.fetch 'url'
_port     = dataset.fetch 'port'
user_name = dataset.fetch 'user_name'
password  = dataset.fetch 'password'

e 'We will use this url:       '+sfancy(url)
e 'We will use this user name: '+sfancy(user_name)
e 'We will use this password:  '+sfancy(password)
ftp = Net::FTP.new(url)
ftp.login(user_name, password) # First the user's name, then the password
pp ftp
pp ftp.list
ftp.close