#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'colours/colours_e_autoinclude.rb'
require 'cliner/autoinclude'
require 'verbose_truth'
require 'ftp_paradise'

e 'Now testing the component '+sfancy('ftp_paradise')+'.'

_ = FtpParadise::Connection.new(:dont_run_yet) { :use_default_dataset }

e
e 'The following Hash should have some data:'
e
pp FtpParadise.dataset?
e
e '(This should have already connected to the remote URL.)'
e
e 'Next, showing whether we are connected to the remote host: '+
  slateblue(VerboseTruth[_.are_we_connected?])
e
e 'We will issue the method .nlst? next:'
e
pp _.nlst?
e
e
e 'Next, show a listing via .list() on the ftp-object:'
e
pp _.list?

e
e 'We will cd on the remote host next, into htdocs:'
e
e _.pwd
_.rcd 'htdocs'
e _.pwd
e
e 'HMM'
e
e 'And get a file-listing (in two different ways):'
e
pp _.list?
e
e "Listing all #{Colours.lightgreen('remote files')} next:"
e
pp _.return_all_remote_files
e
e 'Uploading a file; then showing the remote files, before this file is removed again:'
e
_.upload_this_file   '/Depot/j/test.txt'
pp _.return_all_remote_files
_.remove_remote_file '/Depot/j/test.txt'
pp _.return_all_remote_files
pp _.pwd
_.do_list_content
cliner
e 'Next showing all remote directories:'
e
pp _.return_remote_directories
e
_.rcd '..'
e 'Showing the remote directory listing:'
e
_.show_remote_directory_listing
e
pp _.file_listing_as_entries?
cliner
_.show_file_listing